Pcap_DNSProxy 0.4.9.10-0.4.9.13 更新日志(2018-12-30)：

* 添加实验性 FreeBSD 平台支持 [Meowthink]
* 添加 --log-file 参数，可在启动时指定日志文件的储存位置 [LGA1150/Syrone Wong]
* 添加编译和运行时对库版本的检测 [Syrone Wong/wangmice]
  * LibEvent 最低版本要求为 2.1.8
  * LibSodium 最低版本要求为 1.0.16
  * OpenSSL 最低版本要求为 1.0.2
* 重写 Domain Test 和 ICMP Test 模块
* 参数 --config-file 改名为 --config-path
* OpenSSL 更新到 1.1.1a (macOS)
* Xcode 更新到 10.0 (macOS)
* 调整日志文件的初始输出为 stderr (OpenWrt) [Syrone Wong]
* 修正域名解析大小写相关问题 [muink/WeirdoShaw]
* 修正 Address Hosts 相关问题 [LGA1150]
* 修正 Domain Test 和 ICMP Test 模块的数据包序列号、网络请求策略和时间间隔的问题 [LisonFan]
* 修正 SOCKS 用户认证问题 [SunZhizhong]
* 修正 EDNS Label 过滤算法的问题 [Justsoos]
* 修正 Hop Limits Fluctuation 参数范围不准确的问题
* 修正脚本 echo 参数的问题 (Linux/macOS) [YKilin]
* 注意：对 Windows XP/2003 的支持将在未来一段时间完全终止，敬请留意！
* Release Hash:
  * SHA-3(256):
    * Windows/Pcap_DNSProxy.exe: 617B77E2FC893A142A45B120DE6E81695E860633C49CE05F189CB24B1BF36EE7
    * Windows/Pcap_DNSProxy_x86.exe: 026B36EF01A9DD57853787F643D9874F2A2B88753D1128E644C5D533610CB2DD
    * Windows/Pcap_DNSProxy_XP.exe: 6A7E8F5A947E8DF871B05D7CAF86D59994A20A2699FAB1FEBF6ECDCAB068A227
    * macOS/Pcap_DNSProxy: EE48BE316727F1152636A42DB7BC6087187BF10ADC5E90C52997F9C345E34569
  * SHA-2(256):
    * Windows/Pcap_DNSProxy.exe: FF9A8CB56062BB8506C3E77C4603FE78CCC6FE59C916429236113368D15DA4BE
    * Windows/Pcap_DNSProxy_x86.exe: D2CF9B2FA5A215C2E39EAF30B7CA6001873A6E1F2BE0ADE6C9E7DA1551ED9313
    * Windows/Pcap_DNSProxy_XP.exe: ACB13712956168A594C97E03EE54A15B58C515E97C065CEFCA3A6214062D71CA
    * macOS/Pcap_DNSProxy: 5E4F3C7D5216BD65B85E2B34DCE88F4E9575F8B568DF73019367D5F2D9195E13


-------------------------------------------------------------------------------


Pcap_DNSProxy 0.4.9.5-0.4.9.9 更新日志(2018-07-14)：

* 添加完整的 EDNS 标签透明转发支持
* 添加对 libevent 库的支持
* 添加对根据 DNS 请求类型进行转发选路的的支持 [ccaapton]
* C++ 最低标准要求更新到 14
* LibSodium 更新到 1.0.16 (Windows/macOS)
* OpenSSL 更新到 1.1.0h (macOS)
* Strict Resource Record TTL Filter 改名为 Resource Record Set TTL Filter
* 优化编译参数 (Linux/macOS)
* 修正 Local 请求过程参数的逻辑 [LisonFan/sysconfon/huaji0353/gitlikang]
* 修正请求协议选择的算法，在同时启用 IPv6 和 IPv4 时默认将趋向以相同的协议进行请求 [ccaapton]
* 修正 EDNS Lebel 参数对 All 行为的支持 [muink]
* 修正对 DNSSEC 数据包的过滤算法 [ZeroClover]
* 修正初始化 LibSodium 时的行为，增强安全性
* 修正抓包模块对 IPv4/IPv6 分片数据包的支持
* 修正包含 DNSSEC 相关记录的过滤算法
  * DNSSEC Force Validation 改名为 DNSSEC Force Record
* 修正脚本对文件描述符的软性限制 (Linux) [lunzima]
* 修复 SOCKS 和 HTTP(S) Proxy 协议 TCP 模式下长度判断错误的问题 [LisonFan/laggardkernel]
* 修复部分受支持编译器不支持 -fsplit-stack 参数导致编译失败的问题 [asd2003asd]
* 修复 SOCKS Username 和 SOCKS Password 参数读取的问题 [ダクネスExplosion]
* 修复部分带地址参数重复检测逻辑错误的问题 [cjjdaq]
* 修复 EDNS Client Subnet 启用时部分类型的 DNS 请求会被截断的问题 [mewsf]
* 修复 EDNS Label 以及任何的 Force TCP 同时启用时数据包格式出错的问题 [chenjiajia9411]
* 修复在启用 EDNS Label 同时收到 UDP 协议超长数据包时无法正确设置截断标志位的问题 [debugzxcv]
* 修复抓包模块抓取原生 IPv6 和 ICMP 协议数据包时的错误
* 修复 ICMP/ICMPv6 请求模块的时间控制问题
* 提升 CMake 版本要求到 3.1 (Linux/macOS)
* 移除 IPv4 Data Filter 参数
* 移除 DNSSEC Validation 参数
  * 注意：本工具从未有支持 DNSSEC 完整验证，仅检查是否存在 DNSSEC 相关资源记录，而此功能已整合到 DNS Data Filter 参数中。为避免名称上的误导，特此移除！
* 移除对 Homebrew 的支持 (macOS)
* Release Hash:
  * SHA-3(256):
    * Windows/Pcap_DNSProxy.exe: 462857B5E74356D783D7230F60A662F9462A36F8543E45874376B96E9C1F0FE1
    * Windows/Pcap_DNSProxy_x86.exe: 957C1EBE379E82E3B4AB87B13AAA17A715F8E0906BCC2846F1F591A5602F06A2
    * Windows/Pcap_DNSProxy_XP.exe: C69BCF482203799AF642BC48DCF78DB98B885D7D7E613BB14C1EE32A203E509D
    * macOS/Pcap_DNSProxy: 5372E067FE8941E77E210AE68C684E3019C8F887218536B2947696AF83877670
  * SHA-2(256):
    * Windows/Pcap_DNSProxy.exe: 3E57CF4D09A28D116972B73D4A7C33E7888F4189DD35939955DEFC81C61BA732
    * Windows/Pcap_DNSProxy_x86.exe: E6CE60C25C93456DF9A70BBDB2A2D21EF40254783DC0003561AC4E89CBFC3C10
    * Windows/Pcap_DNSProxy_XP.exe: 8C363476DB55EC55AB1F96C5BB05C84E3B8602F08B9B0992C8ED26FAF8990617
    * macOS/Pcap_DNSProxy: 035D39EA32D70EDBA6B2B7FA6B6C27AB5D91E335DCD0330E5E39C97997FDC8BC


-------------------------------------------------------------------------------


Pcap_DNSProxy 0.4.9.1-0.4.9.4 更新日志(2017-10-06)：

* 添加 Domain Test 探测模块对 TCP 协议的支持
  * 添加 Domain Test Protocol 参数
* 大幅提升 Local Routing 境内路由表和内置 DNS 缓存的查询效率 [Syrone Wong]
* LibSodium 更新到 1.0.15 (Windows/macOS)
* Xcode 更新到 9.0 (macOS)
* OpenSSL 更新到 1.1.0f (macOS)
* 调整境内服务器请求过程的整体策略 [cjjdaq]
  * 移除 Local Main 参数
* 调整内置 IP 地址黑名单的策略
  * 警告：此次更新后所有内置的 IP 地址黑名单将移到 IPFilter 文件，请务必对 IPFilter 文件进行更新，否则有可能造成投毒污染的问题！
* 修正对 TCP 报文的探测过滤算法
* 修正多重实例运行的问题
  * 添加 Process Unique 参数
* 修复网络模块在部分情况下导致崩溃的问题 [goxofy/kalagxw/lunzima/monokoo/pengpengxp/Syrone Wong/wangmice]
* 修复 Local Hosts 白名单识别算法的问题 [cjjdaq/muink]
* 修复 Transaction ID 在取特殊值的情况时无法进行解析的问题 [LisonFan]
* 修复在部分情况下指定多个 Listen Address 时可能造成的错误报错问题
* 修复错误日志输出模块的时间计算问题
* 修复 CNAME Hosts 域名内部 Dnsmasq 格式匹配规则错误的问题
* 修复 NSCI 系统网络感应指示器 IPv6 地址被错误过滤的问题 (Windows) [hnsylzg]
* Release Hash:
  * SHA-3(256):
    * Windows/Pcap_DNSProxy.exe: 8E9EEAFD301C1D27A1B9E6D2CAC692D032621E3E80BB15A3CCA1CCEF3768FA2D
    * Windows/Pcap_DNSProxy_x86.exe: 7EF905162AB37BCF94C229D991773DADE1DF02F635B951DCEF50976B915E4795
    * Windows/Pcap_DNSProxy_XP.exe: 4AF0131A398A75D26ADA5DACBF9E185EEBE78D2A5E4A0787DE16A66EE0496FAE
    * macOS/Pcap_DNSProxy: F5A91990F9DC3022AA016EE9E12659D64ECEF3351139CA2D0630E99CC298F06F
  * SHA-2(256):
    * Windows/Pcap_DNSProxy.exe: 577314F84110F9531CC5E5EFA16622FBA7C0B8E0AE525DA802298A1CE90AB0DD
    * Windows/Pcap_DNSProxy_x86.exe: 6080BD47D3F32E516E1DDCDD399866C05E62D3732132C8111F8D9650C8B84FD2
    * Windows/Pcap_DNSProxy_XP.exe: 54E0E01B6EEFE0875B8DFDD3A673CA57EA6E1DF25D07A1601DECEBDC5962226F
    * macOS/Pcap_DNSProxy: 8C8A225E861517822328E264C3FAFD3E0455352D206EC106DB9FBA5E2F489669


-------------------------------------------------------------------------------


Pcap_DNSProxy 0.4.8.5-0.4.9.0 更新日志(2017-06-03)：

* 添加对根据请求来源 IP 地址有别的 DNS 缓存/每个前缀地址拥有单独 DNS 缓存队列的支持 [LisonFan]
  * 添加 Cache Single IPv4 Address Prefix 参数
  * 添加 Cache Single IPv6 Address Prefix 参数
* 添加对 EDNS Client Subnet Relay 启用时前缀长度跟随固定地址的功能 [LisonFan]
* 添加对 DNSCrypt 数据库文件 dnscrypt-resolvers.csv 配置的支持 [rampageX/snakwu]
* 添加对 HTTP CONNECT 隧道 HTTP/2 版本的支持 [agentmario]
* 添加对 Force TCP/UDP 参数的支持，可强制请求过程只使用所指定的 TCP/UDP 协议
* 添加对 TLS ALPN 扩展的支持
* 添加对 ServiceControl.bat 启动参数的支持，可直接通过在启动时指定参数进行对应的操作 (Windows)
* 添加对指定 TCP Fast Open 的监听队列长度支持 (Linux)
* 添加对 TCP Fast Open 的支持 (macOS)
* LibSodium 库更新到 1.0.12 (Windows/macOS)
* Visual Studio 更新到 2017 (Windows)
* 修复读取文本文件时最后一个字符为有效字符但被忽略的问题 [冰靈曦曉]
* 修复在完全禁用 IPv6 协议栈的情况下程序依旧尝试使用 IPv6 协议栈的问题 [dzxx36gyy]
* 修复 Cache Parameter 参数运作与说明文档不符的问题 [LisonFan]
* 修复 EDNS Client Subnet 数据包前缀长度截断不符合标准的问题 [LisonFan]
* 修复 -c/--config-file 参数在部分情况下无法正常指定路径的问题
* 修复在配置文件重新读取参数有改变的情况下没有进行网络状况重新测试的问题
* 修复 DNSCurve(DNSCrypt) 在配置文件重新读取参数没有改变的情况下可能无法正常工作的问题
* 修复 HTTP CONNECT 隧道在部分服务器先行推送数据时无法正常工作的问题
* 修复 OpenSSL 在部分情况下无法设置套接字属性的问题 (Linux/macOS)
* 修复在启用 TCP Fast Open 多线程请求的情况下部分服务器被跳过的问题 (Linux)
* Release Hash:
  * SHA-3(256):
    * Windows/Pcap_DNSProxy.exe: 55692B5DD0ED42D39091EA7ADB87DA460441D9D18D07D5D87EC3739A5FD6068C
    * Windows/Pcap_DNSProxy_x86.exe: C943F0BF0691B219CED39B968FF073384DD4C3F5C6B1DF36B5072F1BA6FAFBBE
    * Windows/Pcap_DNSProxy_XP.exe: E17101A1B7DFA4AB79B4B68FF2A99C9E1260C20D13BCCB9F2ACD9E84C6C82F3A
    * macOS/Pcap_DNSProxy: 6B13BFED3EEFF32375F1E02CFE19EA4A17DD129CB4245390C698B1F8AFCEDEE0
  * SHA-2(256):
    * Windows/Pcap_DNSProxy.exe: 13AECD65E89913DC3A9AF420872F8DFB67BA52EC1CAC5A6DD4CCCF9FF5A85234
    * Windows/Pcap_DNSProxy_x86.exe: 090B462C0751C7200A428C261D6AADE3AF455D6A8D0324617D44234C4772225C
    * Windows/Pcap_DNSProxy_XP.exe: 0998FC56226D9B8327D353366CF8FB04CED233993CFC0A561226DE385934D6B7
    * macOS/Pcap_DNSProxy: 91AF21E7B704F3894CB1AC658148BBC3019676352BC5F0524BCD2E2176BE3DF8


-------------------------------------------------------------------------------


Pcap_DNSProxy 0.4.8.1-0.4.8.4 更新日志(2017-03-11)：

* 添加 Address Hosts 的前缀长度支持 [LGA1150]
* 添加 EDNS Label 参数名单的排除模式支持 [燒香の貓咪]
* 添加 Strict Resource Record TTL Filter 参数以支持 RFC 2181 标准所要求的资源记录 TTL 检查
* 添加内置的单一实例限制多开支持
* 添加一组 Pcap Devices Blacklist 非必要抓包黑名单 (macOS)
* 标准化 EDNS Client Subnet 的行为
* 解除对 260 字符路径/文件名的内部逻辑限制，相关限制仍会受系统配置所影响 (Windows)
* 改进的 Domain Case Conversion 功能
* 改进在启用手动版本选择时所指定使用的 Ciphers Suites (Linux/macOS)
* Output Protocol 改名为 Outgoing Protocol
* OpenSSL 更新到 1.1.0e (macOS)
* 修改多行注释区域的标签要求 [Monoremonton/wx0]
* 修改全部类型 DNS 缓存的缓存策略 [kraml]
* 修复内存对齐可能造成的性能问题 [Syrone Wong]
* 修复 Operation Mode 参数指定为 Proxy 和 Server 模式时工作不正常的问题 [Syrone Wong/wang20150419]
* 修复预编译二进制版本无法正确运行的错误 (macOS) [fysly]
* 修复在部分情况下 DNS 缓存无法以超时形式移除的问题 [kraml]
* 修复一个可能在部分编译器造成严重内存泄漏的问题
* 修复 IPv6 地址的 Local Routing 在指定部分前缀长度时可能出现的崩溃问题
* 修复 IPv6 地址实际地址与前缀长度所指定的地址不一致的问题
* 修复多行注释区域无法通过其它非多行注释区域标签重置的问题
* 修复 TCP 模式下 SOCKS Proxy 和 HTTP CONNECT Proxy 工作不正常的问题
* 修复 Local Force Request 参数在启用 Local Main 或 Local Routing 功能时工作不正常的问题
* 修复反查本地 IPv6 地址 PTR 记录的问题 (Windows/Linux)
* 修复 32 位系统下可能出现的计算文件占用空间错误的问题 (Windows)
* 修复使用低于 OpenSSL 1.0.1 版本时指定过于严格的规则导致没有任何 Ciphers Suites 可用的问题 (Linux/macOS)
* 修复内存对齐方式不一致可能导致的运行出错的问题 (Linux/macOS)
* 修复在启用 TCP Fast Open 的情况下有几率出现的请求发送失败的问题 (Linux)
* Release Hash:
  * SHA-3(256):
    * Windows/Pcap_DNSProxy.exe: B28B1D013FE4690F809D3D1FFCA0FFAF152C9F2A3201E2596D398F90E78B2657
    * Windows/Pcap_DNSProxy_x86.exe: 04E0783F9BB6175C70EE39182BCEF2C1C3B831E78ABCF2E70641568E7098205D
    * Windows/Pcap_DNSProxy_XP.exe: DF509FDB4EC3EBDF9A734A92864E1B31C48FB102543FD1C3CD800FEB015B2DD7
    * macOS/Pcap_DNSProxy: 4C3FDC39D26EAC29E25238D15D4319230BF1631873CEF68C7EFC260B26C4F4C8
  * SHA-2(256):
    * Windows/Pcap_DNSProxy.exe: 49295353E340B4EBB3FDBAA069C267074C81C1693A9966161B7EFE4AFBA97D1D
    * Windows/Pcap_DNSProxy_x86.exe: 565DEF67183452397957EBF24088C427A8B8DCDD20E81F27804898448D1C6C93
    * Windows/Pcap_DNSProxy_XP.exe: 12705D3715D525C6536B8E662AC648D51C839111B13950EF3ED27FD430E9445A
    * macOS/Pcap_DNSProxy: 479223CD534D4F8D9CEC0DD44AD4BC1EEB85108D5AE8FF3A6EF3AF5C6DFB1501


-------------------------------------------------------------------------------


Pcap_DNSProxy 0.4.7.7-0.4.8.0 更新日志(2016-11-23)：

* 添加 Include Guard Macros 的支持 [Syrone Wong]
* 添加 Large Buffer Size 参数，用于指定大型数据缓冲区的固定长度
* 添加串行请求通讯模块，重写部分网络请求协议
  * 重写 SOCKS Proxy 以及 HTTP CONNECT Proxy 协议实现，解除传输数据量受一次性请求通讯模块固定缓冲区的长度限制
  * 新增 Reliable Serial Socket Timeout 和 Unreliable Serial Socket Timeout 参数控制串行通讯超时时间
  * HTTP Proxy 改名为 HTTP CONNECT Proxy
  * HTTP Protocol 改名为 HTTP CONNECT Protocol
  * HTTP Proxy Only 改名为 HTTP CONNECT Proxy Only
  * HTTP IPv4 Address 改名为 HTTP CONNECT IPv4 Address
  * HTTP IPv6 Address 改名为 HTTP CONNECT IPv6 Address
  * HTTP Target Server 改名为 HTTP CONNECT Target Server
  * HTTP Version 改名为 HTTP CONNECT Version
  * HTTP Header Field 改名为 HTTP CONNECT Header Field
  * HTTP Proxy Authorization 改名为 HTTP CONNECT Proxy Authorization
  * 移除 HTTP Socket Timeout/SOCKS Reliable Socket Timeout/SOCKS Unreliable Socket Timeout 参数
* 添加 HTTP CONNECT Tunnel 单独 TLS/SSL 握手和加密传输的能力
  * TLS/SSL 握手和加密传输由 SSPI/SChannel(Windows) 和 OpenSSL(Linux/macOS) 支持
  * 添加 HTTP CONNECT TLS Handshake 参数，用于开启 TLS 握手功能
  * 添加 HTTP CONNECT TLS Version 参数，用于指定所使用的 TLS 版本
  * 添加 HTTP CONNECT TLS Validation 参数，用于选择是否验证 TLS 服务器证书链
  * 添加 HTTP CONNECT TLS Server Name Indication 参数，用于指定 TLS 握手时所使用的域名
* 添加 IPFilter 和 Hosts 文件临时停止读取标签的区块化支持
* 配置文件版本要求升级到 0.45
  * Protocol 改名为 Output Protocol
  * IPv4 DNS Address 改名为 IPv4 Main DNS Address
  * IPv4 Local Main DNS Address 改名为 IPv4 Local Main DNS Address
  * IPv6 DNS Address 改名为 IPv6 Main DNS Address
  * IPv6 Local DNS Address 改名为 IPv6 Local Main DNS Address
  * IPv4 DNS TTL 改名为 IPv4 Main DNS TTL
  * IPv6 DNS Hop Limits 改名为 IPv6 Main DNS Hop Limits
  * Reliable Socket Timeout 改名为 Reliable Once Socket Timeout
  * Unreliable Socket Timeout 改名为 Unreliable Once Socket Timeout
  * Encryption 改名为 DNSCurve Encryption
  * Encryption Only 改名为 DNSCurve Encryption Only
  * Client Ephemeral Key 改名为 DNSCurve Client Ephemeral Key
  * Key Recheck Time 改名为 DNSCurve Key Recheck Time
  * Client Public Key 改名为 DNSCurve Client Public Key
  * Client Secret Key 改名为 DNSCurve Client Secret Key
  * IPv4 DNS Public Key 改名为 DNSCurve IPv4 Main DNS Public Key
  * IPv4 Alternate DNS Public Key 改名为 DNSCurve IPv4 Alternate DNS Public Key
  * IPv6 DNS Public Key 改名为 DNSCurve IPv6 Main DNS Public Key
  * IPv6 Alternate DNS Public Key 改名为 DNSCurve IPv6 Alternate DNS Public Key
  * IPv4 DNS Fingerprint 改名为 DNSCurve IPv4 Main DNS Fingerprint
  * IPv4 Alternate DNS Fingerprint 改名为 DNSCurve IPv4 Alternate DNS Fingerprint
  * IPv6 DNS Fingerprint 改名为 DNSCurve IPv6 Main DNS Fingerprint
  * IPv6 Alternate DNS Fingerprint 改名为 DNSCurve IPv6 Alternate DNS Fingerprint
  * IPv4 Receive Magic Number 改名为 DNSCurve IPv4 Main Receive Magic Number
  * IPv4 Alternate Receive Magic Number 改名为 DNSCurve IPv4 Alternate Receive Magic Number
  * IPv6 Receive Magic Number 改名为 DNSCurve IPv6 Main Receive Magic Number
  * IPv6 Alternate Receive Magic Number 改名为 DNSCurve IPv6 Alternate Receive Magic Number
  * IPv4 DNS Magic Number 改名为 DNSCurve IPv4 Main DNS Magic Number
  * IPv4 Alternate DNS Magic Number 改名为 DNSCurve IPv4 Alternate DNS Magic Number
  * IPv6 DNS Magic Number 改名为 DNSCurve IPv6 Main DNS Magic Number
  * IPv6 Alternate DNS Magic Number 改名为 DNSCurve IPv6 Alternate DNS Magic Number
* 修复普通格式 Local Hosts 列表读取错误的问题 [muink]
* 修复 Custom 模式下自定义 IPFilter 不能工作的问题
* 修复 SOCKS 4/4a 协议不能工作的问题
* 修复 HTTP CONNECT Proxy 无法正确进行 Basic 验证的问题
* 修复错误报告提供的错误代码格式错误的问题
* 修复 CMake 的缺陷造成的错误依赖问题 (Linux/macOS) [Syrone Wong]
* 修复程序由于系统 Signal 导致的意外退出问题 (Linux/macOS)
* 修复错误详细信息有时可能缺少最后一个字符的问题 (Windows)
* 修复 CMake 编译提示宏重定义的问题 (macOS)
* 移除对 Hosts 文件和 IPFilter 文件的多行注释支持
* 提供 SHA-2(256)/SHA256 文件校验值，淘汰 SHA-1 算法
* Release Hash:
  * SHA-3(256):
    * Windows/Pcap_DNSProxy.exe: 65F41F53AAAD9C18828216EC614D276ADE589CBF877B54D7FC7987C05806021D
    * Windows/Pcap_DNSProxy_x86.exe: D84318648F8EFA3DC8667B002DA5211AC2598D6B28D99A95D2DECB84213E898D
    * Windows/Pcap_DNSProxy_XP.exe: C35A23EC22DD3C0ABC0805E2AF7DE8457D7610EAA6E8E9ECAF2931C1C6E6EF96
    * macOS/Pcap_DNSProxy: 7E26203D5F0388ED5D396D2C665FE50E44725BF85CAA6C41088D9A060E5B40E2
  * SHA-2(256):
    * Windows/Pcap_DNSProxy.exe: 3626D21FD0674830F1D13776EB79626D79F653C65108041F8042CA4DDA62B299
    * Windows/Pcap_DNSProxy_x86.exe: 76EC284B340FD7FFA585E8B9DA7E92F54F72AB3FFEA3F9DC1CEAE13B49005266
    * Windows/Pcap_DNSProxy_XP.exe: C4744E588BEE4C15E3BD3B77F1A71E55F8B8C9677F43D6E8691D8B41885AF602
    * macOS/Pcap_DNSProxy: 8C87587D30F6BB6BEE84F6AF07EA27AB77F110BF905CFFDD890ABAB10492F955


-------------------------------------------------------------------------------


Pcap_DNSProxy 0.4.7.1-0.4.7.6 更新日志(2016-10-10)：

* 添加对 Dnsmasq 的 Address 和 Server 兼容格式配置文件的支持
  * 支持使用 Address 和 Server 兼容格式的非正则表达式模式对域名查询进行字符串匹配
  * 支持使用 Server 兼容格式指定特定境内 DNS 目标服务器以及指定目标服务器请求的端口
  * 附带的 WhiteList.txt 切换到 Dnsmasq Server 兼容格式以降低启用境内白名单功能时的资源占用
* 添加一种时间 + 队列双重检测类型的 DNS 缓存策略
* 添加完整的线程池支持
* 添加对 RFC 6761 特殊域名标准化解析的支持
  * Localhost Server Name 参数改名为 Local Machine Server Name
  * 修改默认的本机名称为 pcap-dnsproxy.server
  * 以 localhost 后缀的域名将全部解析到环回地址
  * 以 invalid 后缀的域名将全部解析为域名不存在
  * 以 test 后缀和 Example Domains 的域名将不作处理
* 添加 CMake 系统并行多线程编译支持 (Linux/Mac)
* 添加服务器端 TCP Fast Open 属性的实验性支持 (Windows)
* 现在输出错误代码时将附上一段对该错误代码的说明 [Syrone Wong]
* Xcode 更新到 8.0 (Mac)
* 修复套接字不正确的关闭有可能造成的系统资源耗尽问题 [AVC A]
* 修复 IPv6 协议套接字参数错误的问题 [gaoyan1234]
* 修复 DNS 缓存清除功能的问题 (Linux/Mac) [kiliwalk]
* 修复在不启用任何 Local 选项同时附带白名单列表时报错的问题
* 修复在程序启动后修改配置文件重新读取时报错的问题
* 修复 dig 请求权威根域名服务器的问题
* 修复 CR + LF 换行格式下行数统计错误的问题
* 修复套接字 TCP Fast Open 属性不生效的问题 (Linux)
* Release Hash:
  * SHA-1:
    * Windows/Pcap_DNSProxy.exe: 04629413231FCE9CCD375E7E08EED21D975E893B
    * Windows/Pcap_DNSProxy_x86.exe: 771551DFE793F5BD28684BEDBE95A67FB32A0F36
    * Windows/Pcap_DNSProxy_XP.exe: 70E6E5C6974846E19C666A3F2494956DCC731F18
    * Mac/Pcap_DNSProxy: 1D8F5D58681B74BD831C7BBED47E126A273C6AB8
  * SHA-3(256):
    * Windows/Pcap_DNSProxy.exe: 0ED522E220D953D5F334FCCCEF1762836C2393AFAD4AD074217A3E5F0E095A4A
    * Windows/Pcap_DNSProxy_x86.exe: 8A1115810A8DA7D3F8A21D37E69A9CBAAF4E0C65B2CB51E60343BD8CDC78D580
    * Windows/Pcap_DNSProxy_XP.exe: 1D96315F010DC6A06A2649589CE214E8E856D49A69D37363BFECD5187FC1C5AD
    * Mac/Pcap_DNSProxy: E730137DA5CE3E6AEBC4EE2180BB45EBF48F8678E7E9A10B1985ADC3C7BF39CA


-------------------------------------------------------------------------------


Pcap_DNSProxy 0.4.6.1-0.4.7.0 更新日志(2016-08-22)：

* 添加 Source Hosts 根据域名请求的来源地址进行 Hosts 的功能
* 添加 Local Force Request 参数，可强制已确定使用境内服务器的域名请求不使用其它服务器进行解析
* 添加 --flush-dns 参数指定域名功能，可清除特定域名的缓存
* 添加遗漏的 DNS 投毒污染黑名单地址
* 添加实验性的线程池支持，并将 Buffer Queue Limits 参数更名为 Thread Pool Maximum Number
* 添加对刷新系统缓存的时间间隔限制 [Syrone Wong]
* 添加 CMake 的 Clang 编译器支持 (Mac)
* LibSodium 库更新到 1.0.11 (Windows/Mac)
* Multi Request Times 参数更名为 Multiple Request Times
* Alternate Multi Request 参数更名为 Alternate Multiple Request
* 合并 KeyPairGenerator 工具到主程序，作为支持参数使用
* 分离 32 位版本对 XP/2003 系统的支持 (Windows)
* 修复数据包过滤模块过于严格导致无法使用部分正常 DNS 服务器的问题 [muink]
* 修复批处理在 2003 系统下无法正常工作的问题 (Windows) [wuxiao2522]
* 修复抓包模块错误判断正确数据包的问题
* 修复抓包模块对 IPv6 数据包识别错误的问题
* 修复 Pcap Devices Blacklist 参数工作不正常的问题
* 修复 Hop Limits/TTL 参数读取不正常的问题
* 修复 Hop Limits/TTL 参数指定的值被覆盖的问题
* 修复由于部分套接字被过早清理造成系统协议栈返回 ICMP/ICMPv6 端口不可达信息的问题
* 移除附带的 FileHash 工具，其将分离至 https://github.com/chengr28/Toolkit 项目继续开发
* 移除对旧版配置文件的兼容
* Release Hash:
  * SHA-1:
    * Windows/Pcap_DNSProxy.exe: DA363FB8F5E3906A1FB65464A0E1343C747DA72C
    * Windows/Pcap_DNSProxy_x86.exe: 96F508BBDB48DD16B0B13D7B58D42F333042F198
    * Windows/Pcap_DNSProxy_XP.exe: 07DB9B0D32E5314E8D46A13F02014D712CD1761D
    * Mac/Pcap_DNSProxy: 9B5EF5662DF6697E0FA5DC66B000EA56996FE30C
  * SHA-3(256):
    * Windows/Pcap_DNSProxy.exe: E51761D6A7F5EDC505CC6281CF880D70EC2828904BC34A133C89875A31499B47
    * Windows/Pcap_DNSProxy_x86.exe: D50D4218D14C8C62F67F3BE845B4D668994D807A8A85C2D8D432C50BEB7E1709
    * Windows/Pcap_DNSProxy_XP.exe: D7342D887B52C4FA87402FF9C4273E7C6F6461CA01FDCADC92253D06FD8E8072
    * Mac/Pcap_DNSProxy: DBF31E10FD8BBA080D16256F2DB062B106A157831C3B9DE2824C61890A63A429


-------------------------------------------------------------------------------


Pcap_DNSProxy 0.4.5.1-0.4.6.0 更新日志(2016-04-23)：

* 为 FileHash 工具添加 Hash 算法支持
  * CRC family: CRC-8 family + CRC-16 family + CRC-24 family + CRC-32 family + CRC-40 + CRC-64 family
    * CRC-8 family: Normal + ITU + ATM + CCITT + Maxim + Icode + J1850 + WCDMA + Rohc + Darc
    * CRC-16 family: Normal + Buypass + DDS 110 + EN 13757 + Teledisk + Modbus + Maxim + USB + T10 DIF + DECT(X) + DECT(R) + Sick + DNP + CCITT Xmodem + CCITT FFFF + CCITT 1D0F + Genibus + Kermit + X25 + MCRF4XX + Riello + Fletcher
    * CRC-24 family: Flexray A + Flexray B + R64(Normal)
    * CRC-32 family: Normal + JamCRC + C + D + BZIP2 + MPEG2 + POSIX + K + Q
    * CRC-64 family: Normal + 1B + WE + Jones
  * Checksum: Internet Protocol Checksum
  * SHA family: SHA-2(384) + SHA-2(512) + SHA-2(512/224) + SHA-2(512/256)
  * MD family: MD2 + MD4 + eD2k Hash + MD5
* 添加抓包模块对 Virtual Bridged LAN/IEEE 802.1Q 标签的支持
* 添加 IPv4 Packet TTL 和 IPv6 Packet Hop Limits 参数，支持指定和随机化的 TTL/Hop Limits 值
* 添加 Update_WhiteList 工具，可自动更新白名单域名列表 [dgeibi]
* 添加错误日志输出分级功能，并将 Print Error 参数更名为 Print Log Level [smounives]
* 添加 IPv4 Do Not Fragment 参数，支持指定 Do Not Fragment 标志 (Windows/Linux)
* 添加 Update_Routing 工具的自动更新脚本 (Linux/Mac)
* 通过外部命令清除程序内部 DNS 缓存的过程，现在将能无延迟地立即完成
* 增强对 EDNS Label 的精细化控制
* LibSodium 库更新到 1.0.10 (Windows/Mac)
* Visual Studio 更新到 2015 (Windows)
* Xcode 更新到 7.2 (Mac)
* IPv4 TTL 参数更名为 IPv4 DNS TTL
* IPv4 Alternate TTL 参数更名为 IPv4 Alternate DNS TTL
* IPv6 Hop Limits 参数更名为 IPv6 DNS Hop Limits
* IPv6 Alternate Hop Limits 参数更名为 IPv6 Alternate DNS Hop Limits
* 修复白名单列表不工作的问题 [lonsx]
* 修复白名单/黑名单列表在 CNAME Hosts 区域内不生效的问题 [shuangzhijinghua]
* 修复一个特定情况下可能导致程序崩溃的问题
* 修复因 errno 造成的错误代码延续问题 [Syrone Wong]
* 修复 Additional Path 失效的问题 [jzp820927]
* 修复 Additional Path/Hosts File Name/IPFilter File Name 参数大小写和空格兼容问题
* 修复使用 Win10Pcap 时抓包模块不能工作的问题 (Windows) [smounives]
* 修复在抓包模式下 CNAME Hosts 格式错误的问题 [debugzxcv]
* 修复程序内部 DNS 缓存被错误自动清除的问题 (Linux/Mac)
* 修复 Update_Routing 工具在 ICMP/ICMPv6 协议被屏蔽的网络下不能工作的问题 (Windows) [w48325832/Syrone Wong]
* 修复重启服务间隔时间过短可能导致的崩溃问题 (Windows)
* Release Hash:
  * SHA-1:
    * Windows/Pcap_DNSProxy.exe: 8805389165915A4611458B28A5C98303F7A6BC6F
    * Windows/Pcap_DNSProxy_x86.exe: 27C6219FFB2A225A56E6D3186B7BE299535DF1F7
    * Mac/Pcap_DNSProxy: 14B86B5CA6BF38D7A242279C2164F53E383CAC52
  * SHA-3(256):
    * Windows/Pcap_DNSProxy.exe: 72930EBF627021684C10C4BBC0988BBBF9CC3F38BE53E93DC4152494CEF88D7F
    * Windows/Pcap_DNSProxy_x86.exe: 04DF32B593D26019545AF121F8551B1632905A7A85506D11E8F83BD174A8C188
    * Mac/Pcap_DNSProxy: 0091474FAEB8CAB2FEF225BCA646A3D46DC0E957FF8AF6F49B8E4FCB9990C1C1


-------------------------------------------------------------------------------


Pcap_DNSProxy 0.4.4.1-0.4.5.0 更新日志(2015-12-30)：

* 添加 FileHash 工具，提供对文件的校验功能
  * 支持 SHA-1
  * 支持 SHA-2(224/256)
  * 支持 SHA-3(224/256/384/512/SHAKE_128/SHAKE_256)
* 添加对 SOCKS 版本 4/4a/5 请求的原生支持
* 添加对 HTTP CONNECT Tunnel 请求的原生支持
* 添加对 CNAME Hosts 的支持 [Hugo Chan/shuangzhijinghua/debugzxcv]
* 添加 DNSCurve Reliable/Unreliable Socket Timeout 参数，增强对不同协议超时设定的精细化控制
* 添加 --lib-version 参数，可输出程序现正使用的库的版本号信息
* EDNS Client Subnet 参数现在更名为 EDNS Client Subnet Relay 并修改了此参数的含义 [XIAOSpider97]
* 增进 DNSCurve 部分的安全性
* LibSodium 库更新到 1.0.8 (Windows/Mac)
* 升级项目文件到 Xcode 7.1 (Mac)
* 调整 GCC 最低版本要求为 4.9 (Linux)
* 调整二进制版本最低系统要求为 10.8/Mountain Lion (Mac)
* 修正 EDNS Client Subnet 功能的转发策略 [XIAOSpider97]
* 修正抓包模块的工作条件 [軒轅無雙]
* 修复读取 IPv4 路由表 CIDR 时的错误 [hocoo]
* 修复 DNS flag AD/Authentic Data 错误设置的问题 (Linux/Mac)
* 修复 DNS ID mismatch 的错误 (Linux/Mac) [hongyi-zhao/cielpy]
* 修复监视模块可能出现的休眠错误 [shuangzhijinghua]
* 修复多次启动程序时可能造成的崩溃问题 (Windows)
* 修复控制台输出内容混叠的问题 (Windows)
* Release Hash:
  * SHA-1:
    * Windows/Pcap_DNSProxy.exe: AC94CDFD0F69A336DE9BFC4A877E3468BFCFAD0C
    * Windows/Pcap_DNSProxy_x86.exe: 938FD04259497D2DD8204F91E51F0B99B108BE57
    * Mac/Pcap_DNSProxy: A9765A1BE67999036C80061CFC66C7EE0191CF90
  * SHA-3(256):
    * Windows/Pcap_DNSProxy.exe: 4CFC917AFD6DE227710CBBA5B6C8A6A4F0BDF8216E9FBE8B26E1F195F2E8AD12
    * Windows/Pcap_DNSProxy_x86.exe: CF36584F70E1EE30F0AB1FB445A4D0971067540F7F7BA3C45C0F0B08984A9066
    * Mac/Pcap_DNSProxy: C653A3DA815BDF5C8995803F105DB666ADB31EC57C942411297469D69C4CA7F9


-------------------------------------------------------------------------------


Pcap_DNSProxy 0.4.3.1-0.4.4 更新日志(2015-09-27)：

* 添加 Client Ephemeral Key 一次性客户端密钥对功能，增强 DNSCurve 协议传输数据的安全性 [DNSCrypt]
* 添加对配置文件部分参数的自动刷新功能，具体受支持的参数参见说明文档 [jedisct1/icylogic]
* 添加 Local Protocol 参数用于指定请求境内服务器时所使用的协议组合 [muink]
* 添加对十六进制 DNSCurve(DNSCrypt) 协议 Magic Number 参数的支持 [BiliBbb]
* 增强 DNSCurve Protocol 参数对协议组合的支持
* 增强 NULL 扩展 Hosts 白名单功能的支持，现在可以指定只对部分 DNS 类型生效
* 添加对 BIND 9.2.0 之后版本清除 DNS 缓存的命令 (Linux) [hongyi-zhao]
* 修正 Local Main 模式生效时对 Local Hosts 列表的读取策略 [c1024/gaoyan1234]
* 修正 Receive Waiting 参数的含义以及对请求行为的影响
* 修正 Local Hosts 参数启用时解析域名的流程，提高已缓存解析结果的解析速度 [hongyi-zhao]
* 修正对并行请求的数量限制
* 修复部分参数读取使用网络层服务名/DNS 记录名称代替数字时的错误
* 修复多线程模式下服务器连接失败时无法切换的问题
* 修复 TCP 协议请求时可能造成的分片问题
* 修复 ICMP/ICMPv6 附加数据长度的计算问题
* 修复 32 位系统对 IPv4/IPv6 地址转换的错误 (Windows Vista+) [Nine Forty/fabe004]
* 修复 ICMP/ICMPv6 套接字参数在默认情况下造成 Ping 功能不正常的问题 (Linux/Mac)
* 修复启用 TCP 协议时 Local 请求造成程序崩溃的问题 (Linux/Mac)
* 修复 Additional Path 参数读取不完全的问题 (Linux/Mac)
* 修复不启用 TCP Fast Open 时发送请求可能会出现的问题 (Linux)
* 修复重新读取 IPFilter 和 Hosts 文件时的顺序问题
* 修复部分情况下不输出 Error.log 文件的错误 (Linux/Mac) [hongyi-zhao]
* 移除清除 DNS 缓存失败时错误消息的输出，此消息对运行没有影响 [Syrone Wong]


-------------------------------------------------------------------------------


Pcap_DNSProxy 0.4.2.1-0.4.3 更新日志(2015-07-28)：

* Hosts Only 参数现在更名为 Direct Request 并支持指定 IPv4 或 IPv6 功能
* 添加不同协议的 Direct Request 功能 [AVC A]
* 添加 Pcap Devices Blacklist 参数，可指定不对含有此名称的网络适配器进行抓包
* 添加限制请求数量的功能
* 添加 DNS 压缩指针检查功能，避免接受格式错误的数据包
* 添加遗漏的 DNS 投毒污染黑名单地址
* 添加对 Unicode 标准包含的所有换行以及空格类别格式的支持
* 添加对 TCP Fast Open 的支持 (Linux)
* 添加 --disable-daemon 参数，可控制程序是否以 Daemon 守护进程的方式运行 (Linux)
* 添加完整的 ASCII/UTF-8/UTF-16(LE/BE)/UTF-32(LE/BE) 编码支持
* 调整抓包模块为回调模式降低资源的占用
* 调整抓包模块工作模式，避免 WinPcap 与 cFosSpeed 之间的冲突 [軒轅無雙]
* 优化优先指定网络层协议功能
* 优化对大小写敏感字符的读取
* 优化对 Hosts 和 Local Hosts 的读取和检测 [yuyangzxw/gaoyan1234]
* 修复抓包模块非 Ethernet 和 Apple IEEE 1394/FireWire 设备的错误识别
* 修复数据包过滤模块的算法错误 [AVC A]
* 修复文件读取模块对于前后留空的错误 [wen kangcheng]
* 修复文件读取模块对于多重空格处理的问题 [yuyangzxw]
* 修复 KeyPairGenerator 生成客户端密钥对的错误 [Syrone Wong]
* 修复 Accept List 参数读取 DNS 类型名称的错误 [Syrone Wong]
* 修复 Address Hosts 功能溢出错误 [jzp820927]
* 修复当请求的数据中带有 EDNS Label 时的错误 [Syrone Wong]
* 修复收到截断数据包时无法重新按照标准适用 TCP 协议重新解析的错误 [shuangzhijinghua]
* 修复睡眠或休眠前可能产生的错误报告输出 (Windows)
  * 启动第一次遇到 Insufficient privileges or not any available network devices 错误信息时将暂时不输出到错误报告文件
  * 移除 An error occurred in XXX 错误信息
* 终端窗口也将输出错误信息
  * 运行在非 Daemon 守护进程模式下的终端窗口时 (Linux)
  * 任何时候 (Mac)
* 移除服务管理批处理的强制管理员权限请求 (Windows) [5sq]


-------------------------------------------------------------------------------


Pcap_DNSProxy 0.4.1.1-0.4.2 更新日志(2015-06-04)：

* 添加对 EDNS Client Subnet 的支持
* 增强对 DNSSEC 的请求能力以及添加不完整的认证功能
* 添加对 Local 境内 DNS 服务器的路由表检查，但只会进行提示而不会中断程序的运行
* 添加 DNSSEC Force Validation 参数，可强制携带 DNSSEC 记录的域名解析才能被接受
* 添加 -c/--config-file 参数，可在启动时指定配置文件的目录 [BlackGear]
* 添加 -v/--version 参数，可输出程序的版本号 [BlackGear]
* 添加对 homebrew 的支持 (Mac) [BlackGear]
* 添加可用于卸载服务的 Shell 脚本 (Linux/Mac)
* 添加不终止程序运行的错误提示类型
* 为 Protocol 参数添加优先指定网络层协议功能
* 配置文件新增 cfg 扩展名的支持
* 修改读写执行权限的设置，以增加安全性 [BlackGear]
* EDNS0 Label 参数改名为 EDNS Label


-------------------------------------------------------------------------------


Pcap_DNSProxy 0.4.0.1-0.4.1 更新日志(2015-05-21)：

* 添加 Pcap Reading Timeout 参数自定义抓包模块读取超时/间隔时间
* 添加 Receive Waiting 参数自定义数据包接收等待时间，丢弃过早达到可能为伪造的数据包
* 添加剥离 LibPcap 库的选项 (Linux)
* 调整抓包模块的超时时间保证回复及时被抓取 [France is Bacon]
* 调整数据包过滤的参数避免误伤部分权威 DNS 服务器 [France is Bacon]
* 调整 DNS 缓存的机制只缓存有结果的数据包 [shuangzhijinghua]
* 視窗模式運行提示將不會寫入錯誤報表中 (Windows)
* 修复 Hosts 条目过长导致数据包溢出的问题 [yfdyh000]
* 修复 Local Hosts 无法读取的问题 [France is Bacon]
* 修复 Hosts 添加 EDNS 标签的问题
* 修复随机域名生成模块产生非标准域名查询的错误
* 调整在关闭抓包模块时请求域名解析的策略
* 移除覆盖系统 Hostname 的行为 (Mac) [messiahluo]
* 移除之前尚未完成的打印详细运行日志的功能


-------------------------------------------------------------------------------


Pcap_DNSProxy v0.4(Windows/Linux/Mac) 更新日志(2015-05-13)：

* 添加对 Apple IEEE 1394/FireWire 的支持
* 添加对 Streamlined/精简格式 DNSCurve(DNSCrypt) 协议的支持
  * 提供随机 Curve25519/Salsa20/Poly1305(DNSCurve) 密钥对生成程序 KeyPairGenerator
* 添加缓存 DNS 回复包的功能
* 添加切换备用服务器，提供主要服务器和备用服务器自动切换的功能
  * 可自定义切换的条件（请求失败次数、失败次数计数周期、重置切换的时间长度）
* 添加 Local Main 主要境内服务器请求功能
  * 即平时使用 Local 服务器进行解析，遇到遭投毒污染的解析结果时自动再向境外服务器请求
  * 解析的结果是否会被投毒污染与使用的伪包过滤器有关，详细情况参见说明文档
* 添加接收到一个解析请求向同一个远程服务器发送多次解析请求的功能，可提高远程服务器丢包时域名解析的可靠性
* 添加自定义请求服务器端口的功能
* 添加自定义本地监听地址和端口的功能
* 添加本地多监听地址/多监听端口的功能
* 添加以 DNS 请求的类型为条件的屏蔽功能
* 添加 IPv6 6to4/ISATAP/Teredo 隧道的支持
* 为本地服务器监听 IPv4/IPv6 增加控制选项（请求时相同协议优先，不同协议 IPv6 优先）
* 添加 Domain Case Conversion/随机转换域名请求大小写 的功能，默认为开启
* 添加 Compression Pointer Mutation/随机添加压缩指针 的功能，默认为关闭
* 为抓包模块添加总开关 Pcap Capture
* 为抓包模块添加 IPv4 扩展头部的支持
* 为 TCP Data Filter/TCP 数据包过滤器添加检查 Checksum/校验和的功能
* 为 IPv4/IPv6 黑名单地址过滤功能添加新的投毒污染地址
* 黑名单地址过滤功能应用到所有解析过程以避免权威服务器被污染的情况下所有结果被投毒污染的结果
* 为 Operation Mode 增加 Private 和 Custom 模式 [陈斐]
  * Private 模式只允许私有网络请求解析
  * Custom 模式禁止或只允许列表中的地址请求解析，使用单独的地址过滤库（支持 IPFilter.dat 和 Guarding.P2P 格式）进行控制
* 为 IPFilter 地址过滤库添加黑名单解析结果过滤功能
* 添加对超过 UDP 协议最大不分片长度的截断数据包使用 TCP 协议重试的功能
* 添加对 EDNS 标签和 DNSSEC(AD/CD/DO) 请求功能的支持（开启 DNSSEC 请求后必须强制添加 EDNS 标签）
* 添加 Hosts Only 直连模式只使用本工具具有正则表达式的 Hosts 功能
* 添加 Local Routing 本地路由表功能
* 添加自定义 Hosts 生存时间的功能
* 程序配置文件和 Hosts 文件版本升级到 v0.4
  * 支持的一行最大长度增到 4KB/4096 bytes
  * 添加新的单行和多行注释格式支持
  * 为 Hosts 文件添加 CSV/逗号分隔值 格式的支持
  * 为 Hosts 文件添加 "BANNED 正则表达式"（不含引号）语法直接返回域名查找失败信息，用于快速屏蔽域名
  * 为 Hosts 文件添加 "BANNED:xxx 正则表达式"（不含引号）语法屏蔽特定类型记录的域名查询
  * 为 IPFilter 数据库添加 "IP地址 ALL"（不含引号）语法直接屏蔽所有含此 IP 地址/地址范围的解析结果
  * URI 标准化 IPv6 地址格式，IPv4/IPv6 地址格式更改为带端口格式
  * 支持部分非标准的缩略 IPv4/IPv6 地址格式
  * 支持检查文件大小的功能
  * 支持自定义文件最大占用空间的设定
  * 支持自定义 Hosts 和 IPFilter 数据库文件名称的功能
  * 为数据库添加排序的功能，避免因为错误的顺序造成问题
  * 在开启散列算法特征检测文件改变以及开启 DNS 缓存的情况下，自动更新 Hosts 列表和 IPFilter 数据库时将自动清空程序的 DNS 缓存
  * 在开启散列算法特征检测文件改变的情况下，自动更新 Hosts 列表时将自动清空系统 DNS 缓存
  * 重写文本文件编码读取模块，支持混合换行格式编码（但不建议使用）
  * 可兼容 v0.3 以前的文件版本，但强烈建议升级为当前版本 v0.4
* 添加窗口模式以支持在安全模式下的运行 (Windows)
* 错误报告在窗口模式下现在会实时显示 (Windows)
* 添加剥离 Libsodium 库的选项 (Linux)
* 请求本地服务器的完整网域名称现在会返回本地服务器的所有 IPv4/IPv6 地址
* 调整请求本地 DNS 服务器由抓包模式到直连模式，加快响应速度降低资源占用
* 调整 IPv4 Data Filter/IPv4 数据包过滤器，默认为关闭
* 调整 ICMP 和随机域名请求模块的编号和序列号生成规则
* 调整 ICMP 附加数据限制长度最长到 1464 bytes(Ethernet MTU - IPv4 Standard Header - ICMP Header)
* 调整随机域名生成模块，使用 C++ STL 提供的梅森旋转算法引擎产生离散型均匀分布的随机域名
* 调整内置默认本地服务器完整网域名称为 "pcap-dnsproxy.server"（不含引号）以遵循域名系统的标准
* 调整内存分配策略（标准以太网 MTU 长度、数据包缓冲区长度和 STL 标准库调用）减少资源占用
* 调整错误报告为带 BOM 的 UTF-8 编码，避免可能产生的乱码问题 [Hugo Chan]
* 调整正则表达式为完全匹配模式，提供更准确的匹配效果 [Hugo Chan]
* 合并 x86 和 x64 版本可执行文件 (Windows) [Hugo Chan]
* 改进首次启动时进行的防火墙测试模块 (Windows)
* 改进无法找到或禁用重启网络适配器后自动重试的功能
* 改进抓包模块的回复机制，降低资源占用
* 使用 CMake 套装编译 (Linux)
* 为 Debian 系 Linux 发行版提供服务控制脚本自动安装脚本
* 移除生成错误报告
  * 找不到 Hosts 文件时
  * Windows XP 系统下不支持 IPv6 时
* 修复超过额定长度（本次更新前为 2 KB）的文件读取能会造成的错误
* 修复 UDP 协议下过早关闭端口造成系统发送 ICMP(v6) Port Unreachable 端口不可到达信息的错误
* 修复 TCP 协议下因为远程服务器无响应而造成的过长时间不回应请求的错误
* 修复存在网桥适配器时可能造成的崩溃 [JonyOang]
* 修复多线程模型下竞争读写全局对象可能造成的错误
* 修复本地监听端口可能被盗用的安全问题 (Windows)
* 修复因为系统默认 IPv6/IPv4 套接字配置造成的冲突问题 (Linux)
* 修复自身服务器名称读取和 IPv6 环境下回复自身服务器名称的错误
* 修复反向解析域名时回复自身服务器名称到所有私有网络地址对应域名的错误
* 修复在 IPv6 环境下抓包回复时的匹配错误
* 修复网络适配器被禁用重启后 WinPcap/Libpcap 无法抓取数据包的错误
* 修复特殊 IPv4/IPv6 地址检测模块的错误
* 修复随机域名生成模块可能生产空域名(ROOT)的错误
* 修复超长 Hosts 条目可能导致的溢出错误以及最短长度限制的问题
* 修复部分情况下无法读取文件最后一行的错误 [Hugo Chan]
* 服务现在将设定为在第一次和第二次遇到错误时自动重新启动 (Windows) [yfdyh000]
* 程序启动时将不再删除错误和运行日志文件 [yfdyh000]
* 合并批处理 (Windows) [yfdyh000]
* 修复批处理在开启 UAC 的情况下无法使用的错误 (Windows) [Haruyuki Arita/Hugo Chan/Ryans233/streamgo/watchingyoufall]
* 在非管理员权限下运行批处理无法修改系统服务信息的错误现在将有提醒 (Windows) [Haruyuki Arita/Hugo Chan/Ryans233/watchingyoufall]
* 源代码现在开始将使用 UTF-8 编码
* 项目升级到 Visual Studio 2013 (Windows)
* 修复在 IPv6 环境下抓取来自境内域名解析服务器回复包的错误，但此功能在新版已被移除，特此公告 [David Webb/eqielb]
* 修复 Makefile 的错误，但此功能在新版已被移除，特此公告 (Linux) [otakuchiyan]


-------------------------------------------------------------------------------


Pcap_DNSProxy v0.3.2(Windows)/v0.2(Linux)/v0.1(Mac) 更新日志：

* Pcap_DNSProxy v0.1 Mac Release 正式发布！
* 提供可用于 x86 和 x64 环境的可执行文件 (Linux)
* 启用对 Ethernet 设备的识别 (Linux)
* 修复在错误使用低权限运行程序可能造成的 bug
* 修复在部分情况下错误生成错误报告的 bug (Linux)
* 修正说明文档的错误操作 (Linux)


-------------------------------------------------------------------------------


Pcap_DNSProxy v0.3.1(Windows)/v0.1(Linux) 更新日志：

* Pcap_DNSProxy v0.1 Linux Release 正式发布！
* 剥离并更新 IPv4/IPv6 保留地址列表过滤模块 (Windows)
  * 升级解析结果黑名单地址过滤功能
  * 修复本地 IPv6 地址获取功能的 bug
  * 修复自动刷新本地地址的 bug
* 修复本地可通讯地址识别错误的 bug (Windows)


-------------------------------------------------------------------------------


Pcap_DNSProxy v0.3 更新日志：

* 32 位/x86 版本使用 WSAAddressToString() 和 WSAStringToAddress() 替代 inet_ntop() 和 inet_pton() 以支持 Windows XP 以及更旧的系统 [Roy Tam]
* 添加对固定列表域名请求境内域名解析服务器的功能 [陈斐]
* 为 Windows 防火墙测试添加 IPv6 版本支持
* INI 版本和 Hosts 版本更新至 0.3
  * 为配置文件添加版本检测功能
  * 为 Hosts 添加白名单功能
* 更新配置文件读取模块
  * 修复部分编码/换行格式下错误输出行数至错误报告的 bug
  * 修复 Hosts 文件一定情况下错误识别注释的 bug
  * 增强对不同换行格式的识别
* 修复 ICMP(v6)/Ping 测试模块的 bug
* 修复白名单域名请求测试在 TCP 模式下被禁用的 bug
* 修复 WinPcap 抓取数据包线程退出后可能导致的内存泄漏问题
* 注释 Console 和部分 Ethernet 的调试代码
* 源代码全部转为 USC-2(Little-Endian) 编码和 Windows(CR-LF) 档案格式


-------------------------------------------------------------------------------


Pcap_DNSProxy v0.2 更新日志：

* 重写编码读取模块，新增支持 Macintosh(CR) 换行格式
* 修复无法在 PPPoE 环境下使用的 bug
* 使用 C 语言标准库返回值
* 宏定义错误报告类型


-------------------------------------------------------------------------------


Pcap_DNSProxy v0.1 更新日志：

* v0.1 Release 正式发布！
